//
// makes output file for graphing
//

#include "fitline.h"

void mk_outfile(data* dp, result* rp, flags* fp ) {

    dbl ylim1, ylim2 ;
    int j ;
    char tmp[100], tmp1[100] ;          // arrays for strings
    char* q ;

    dp->xmin -= FRACT*( dp->xmax - dp->xmin );  // extend lims by FRACT
    dp->xmax += FRACT*( dp->xmax - dp->xmin );  // extend lims by FRACT

    ylim1 = rp->a * dp->xmin + rp->b;           // corresponding ylims
    ylim2 = rp->a * dp->xmax + rp->b;

    if ( fp->o == GOP ) {               // "goplot" outputfile
        fprintf(rp->ofp, "%g\t%g\n", dp->xmin, ylim1);
        fprintf(rp->ofp, "%g\t%g\n", dp->xmax, ylim2);
        fprintf(rp->ofp, "%s\n", "$$$$$$$$$$$$$$$$");
        for ( j = 0 ; j < dp->npts ; j++ ) {
            if ( fp->sflg ) {
                fprintf( rp->ofp, "%g\t%g\t%g\n",
                    dp->x[j], dp->y[j], dp->s[j] );
            }
            else {
                fprintf( rp->ofp, "%g\t%g\n",
                    dp->x[j], dp->y[j] );
            }
        }
    }
    if ( fp->o == GNU ) {               // create gnuplot script
        strcpy( tmp, rp->nam );         // tmp is datafile.gnu
        q = strstr( tmp, ".gnu" );      // q points to the .gnu tag
        assert( q ) ;
        *q = '\0';                      // tmp is now datafile
        fprintf( rp->ofp, "%s",         // create gnuplot script file
          "set term X11\n"
          "#\n"
          "# comment out the next command if you\n"
          "# really want an ugly key on the graph\n"
          "#\n"
          "set nokey\n"
          "#\n"
          "# the following plot function uses an awk filter\n"
          "# to eliminate comment lines from the datafile\n"
          "#\n"
          "plot " ) ;
        fprintf( rp->ofp, "[%f:%f] %f *x + %f ,", // plots the line
            dp->xmin, dp->xmax, rp->a, rp->b ) ;
        fprintf( rp->ofp, "%s",      // plots the data
          "\\\n \"< awk \'BEGIN{FLG=0} $0 ~/==/"
          "{if(FLG) FLG=0;else FLG=1;next}"
          "\\\n {if(!FLG && !index($0,\\\"//\\\"))"
          " print $0 }\' " ) ;
        fprintf( rp->ofp, "%s \"", tmp ) ;
        if ( fp->sflg ) {
            fprintf( rp->ofp, "%s", " with errorbars\n" ) ;
        }
        else {
            fprintf( rp->ofp, "%s", " with points\n" ) ;
        }

        fprintf( rp->ofp, "%s",
          "pause -1 \"\\n\\t\\t hit \140q\047 and \140return\047 to exit ...\"") ;
    }
    if ( fp->o == GNUPS ) {
        strcpy( tmp, rp->nam ) ;
        q = strstr( tmp, ".gnups" ) ;
        assert( q ) ;
        *q = '\0' ;                   // tmp is now datafile
        strcpy( tmp1, tmp ) ;         // save for later use
        strcat( tmp, ".ps" ) ;
        fprintf( rp->ofp, "%s",
          "# the next two commands may be altered to produce\n"
          "# different kinds of postscript files.\n"
          "# see \"help postscript\" under \"gnuplot\" for suggestions.\n"
          "#\n"
          "set term post monochrome\n"
          "set size 0.8, 0.8\n"
          "set output \"" ) ;
        fprintf( rp->ofp, "%s\"\n", tmp ) ;
        fprintf( rp->ofp, "%s",
          "#\n"
          "# comment out the next command if you\n"
          "# really want an ugly key on the graph\n"
          "#\n"
          "set nokey\n"
          "#\n"
          "# the following plot function uses an awk filter\n"
          "# to eliminate comment lines from the datafile\n"
          "#\n"
          "plot " ) ;
        fprintf( rp->ofp, "[%f:%f] %f *x + %f ,", // plots the line
            dp->xmin, dp->xmax, rp->a, rp->b ) ;
        fprintf( rp->ofp, "%s",      // plots the data
          "\\\n \"< awk \'BEGIN{FLG=0} $0 ~/==/"
          "{if(FLG) FLG=0;else FLG=1;next}"
          "\\\n {if(!FLG && !index($0,\\\"//\\\"))"
          " print $0 }\' " ) ;
        fprintf( rp->ofp, "%s \"", tmp1 ) ;
        if ( fp->sflg ) {
            fprintf( rp->ofp, "%s", " with errorbars\n" ) ;
        }
        else {
            fprintf( rp->ofp, "%s", " with points\n" ) ;
        }

// what a pain to create these next lines
        fprintf( rp->ofp, "%s%s%s%s%s",
          "\nprint \"\\nGood.  The PostScript file \\\"",
          tmp,
          "\\\" has been created.\\n\\\n"
          "To view your graph, try giving the command\\n\\n\\\n"
          "\\t\\\"gv ",
          tmp,
          "\\\"\\n" ) ;
    }
    gfclose( rp->ofp ) ;
}
